{    var   : }
{ N, N, M, L }
Unit mni1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNI21_p, MNI26_p, MNRDN_p, MNI31_p, MNI11_p, MNRDS_p;

procedure mni1e(var N :Integer; var X :Array of Extended;
                var A :Array of Extended; var B :Array of Extended;
                var M :Integer; var L :Integer;
                var F :Array of Extended; FUN :Proc_F4E_MN;
                var G :Array of Extended; GRAD :Proc_F5E_MN;
                var UP :Array of Extended; var I0 :Array of Integer;
                var RM :Array of Extended; var IW :Integer; MNI :Proc_MNI07);

implementation

procedure mni1e(var N :Integer; var X :Array of Extended;
                var A :Array of Extended; var B :Array of Extended;
                var M :Integer; var L :Integer;
                var F :Array of Extended; FUN :Proc_F4E_MN;
                var G :Array of Extended; GRAD :Proc_F5E_MN;
                var UP :Array of Extended; var I0 :Array of Integer;
                var RM :Array of Extended; var IW :Integer; MNI :Proc_MNI07);
var
NI,KMAX,NP,KP,K1,K2,K3,K4,K5,K6,K7,I :Integer;
T,E1 :Real;
FX,FS,FZ,MG1,MP1,R1,R2,R3,R4 :Extended;
label
_1,_2,_4,_5,_10,_15,_16,_18,_20,_21,_22,_35,_36,_37,_38,_40,_45,_46,
_50,_51,_52,_54,_55,_57,_60,_65,_70,_73,_75,_76,_77,_78,_80,_85,_90,
_95,_100;
begin
_MNI3.elm7 := Trunc( UP[14] );
FZ := 1.e+36;
if ( L > 1 ) 
 then goto _1;
_MNI4.elm9 := 134;
_MNI4.elm2 := UP[7];
_MNI4.elm1 := UP[6];
goto _2;
_1:
_MNI3.elm3 := UP[1];
_MNI4.elm3 := UP[10];
_MNI4.elm1 := UP[11];
_MNI4.elm2 := UP[12];
_MNI4.elm14 := 1;
_MNI4.elm9 := 1;
_MNI3.elm1 := UP[0];
_MNI3.elm2 := _MNI3.elm1-1.0;
_MNI4.elm4 := 10.0;
_2:
NI := 0;
_MNI3.elm4 := 0;
_MNI3.elm5 := 0;
IW := 0;
_MNI4.elm8 := Trunc( UP[3] );
_MNI4.elm11 := Trunc( UP[4] );
KMAX := Trunc( UP[13] );
NP := Trunc( UP[8] );
KP := Trunc( UP[9] );
_MNI4.elm5 := 1;
K1 := 2*N+1;
K2 := Trunc(IntPower(N,2)+2*N+1);
K3 := Trunc(2*IntPower(N,2)+2*N+1);
K4 := K3+5*N-1;
K5 := K3+6*N-1;
K6 := K3+7*N;
K7 := K3+N-1;
_MNI4.elm13 := N-1;
_MNI3.elm6 := M+1;
_MNI4.elm12 := 1.e-20;
MNI21(FUN,N,M,L,X,FX,F,FS);
_4:
MNI26(GRAD,N,M,L,X,F,G,I0,RM[K4+0]);
_5:
for I:=1 to N do
 begin
_10:
  G[I-1] := RM[K4+I-1]+_MNI3.elm3*RM[K5+I-1];
 end;
MNRDN(G,N,_MNI4.elm6);
FX := F[0]+_MNI3.elm3*FS;
_15:
_MNI4.elm10 := 0;
_16:
for I:=1 to N do
 begin
  if ( X[I-1] < A[I-1]+_MNI4.elm1 ) and ( G[I-1] > 0.0e0 ) 
   then G[I-1] := 0;
  if ( X[I-1] > B[I-1]-_MNI4.elm1 ) and ( G[I-1] < 0.0e0 ) 
   then G[I-1] := 0;
_18:
 end;
MNRDN(G,N,_MNI4.elm7);
if ( NP <> 0 ) or ( KP = 0 ) or ( NI <> 0 ) 
 then goto _20;
MNI31(N,M,L,NI,X,FX,F);
_20:
if ( _MNI4.elm7 <= _MNI4.elm12 ) 
 then goto _77;
_21:
if ( NI >= KMAX ) 
 then goto _85;
_MNI4.elm14 := _MNI4.elm9;
NI := NI+1;
MNI11(FUN,GRAD,N,M,L,A,B,X,FX,
     F,FS,G,I0,RM[K1-1],RM[K2-1],RM[K3-1],RM[K6-1],MNI);
if ( NI < NP ) or ( KP = 0 ) or ( ((NI-NP) Mod (KP)) <> 0 ) 
 then goto _22;
MNI31(N,M,L,NI,X,FX,F);
_22:
if ( _MNI4.elm9 = 9 ) 
 then goto _90;
if ( L > 1) or (_MNI4.elm9 <> 4 ) 
 then goto _35;
_MNI4.elm9 := 134;
goto _21;
_35:
if ( _MNI4.elm9 = 13 ) 
 then goto _70;
if ( _MNI4.elm9 = 5 ) 
 then goto _77;
if ( _MNI4.elm9 = 4 ) 
 then goto _45;
if ( FS <= _MNI4.elm3 ) 
 then goto _37;
_36:
if ( _MNI4.elm11 = 1 ) 
 then _MNI4.elm1 := _MNI4.elm5*0.1;
_MNI3.elm3 := _MNI3.elm3*UP[2];
goto _5;
_37:
for I:=1 to N do
 begin
_38:
  RM[I-1] := X[I-1];
 end;
_40:
FZ := FX;
_MNI4.elm11 := Trunc( UP[4] );
_MNI4.elm9 := 134;
goto _21;
_45:
if ( FZ >= FX ) 
 then goto _50;
_MNI4.elm4 := EMax1(_MNI4.elm4/2.0,1.0);
for I:=1 to N do
 begin
  X[I-1] := RM[I-1];
_46:
  G[I-1] := RM[N+I-1];
 end;
FX := FZ;
_MNI4.elm6 := MG1;
_MNI4.elm7 := MP1;
_MNI4.elm9 := 134;
goto _21;
_50:
for I:=1 to N do
 begin
  RM[K7+I-1] := RM[K4+I-1];
  RM[N+I-1] := X[I-1]-RM[I-1];
  if ( X[I-1] > A[I-1]+_MNI4.elm1 ) 
   then goto _51;
  if ( RM[K4+I-1] > 0.0e0 ) 
   then RM[K7+I-1] := 0.0e0;
  if ( X[I-1] < RM[I-1] ) 
   then RM[N+I-1] := 0.0;
_51:
  if ( X[I-1] < B[I-1]-_MNI4.elm1 ) 
   then goto _52;
  if ( RM[K4+I-1] < 0.0e0 ) 
   then RM[K7+I-1] := 0.0e0;
  if ( X[I-1] > RM[I-1] ) 
   then RM[N+I-1] := 0.0;
_52:
 end;
MNRDN(RM[N+0],N,R1);
MNRDN(RM[K7+0],N,R2);
T := 0.0;
if ( R2 <= _MNI4.elm12 ) 
 then goto _37;
_54:
for I:=1 to N do
 begin
_55:
  RM[I-1] := RM[N+I-1]*(1-T)/R1-T*RM[K7+I-1]/R2;
 end;
MNRDN(RM[0],N,R4);
if ( R4 <= _MNI4.elm12 ) 
 then goto _57;
MNRDS(RM[K7+0],RM[0],N,R3);
R3 := R3/R4;
if ( R3+_MNI4.elm12 < 0.0e0 ) 
 then goto _60;
_57:
T := T+0.1;
goto _54;
_60:
for I:=1 to N do
 begin
  RM[K7+I-1] := RM[I-1]/R4;
  RM[N+I-1] := G[I-1];
_65:
  RM[I-1] := X[I-1];
 end;
FZ := FX;
MP1 := _MNI4.elm7;
MG1 := _MNI4.elm6;
FX := F[0];
_MNI4.elm9 := 4;
E1 := _MNI3.elm3;
_MNI3.elm3 := 0.0;
if ( _MNI4.elm3 > _MNI4.elm5 ) 
 then _MNI4.elm5 := _MNI4.elm3;
MNI(FUN,A,B,N,M,L,RM[0],FX,F,FS,X,RM[K7+0],R3,RM[K6-1]);
_MNI3.elm3 := E1;
_MNI4.elm11 := Trunc( UP[4] );
_MNI4.elm9 := 134;
goto _4;
_70:
if ( FS <= UP[5] ) and ( _MNI4.elm5 <= UP[6] ) 
 then goto _76;
if ( FS <= UP[5] ) 
 then goto _75;
_73:
_MNI4.elm9 := 1;
_MNI3.elm3 := _MNI3.elm3*UP[2];
_MNI4.elm4 := 10.0;
_MNI4.elm3 := FS*0.1;
if ( _MNI4.elm3 > 0.1 ) 
 then _MNI4.elm3 := 0.1;
goto _5;
_75:
_MNI4.elm9 := 134;
_MNI4.elm11 := Trunc( UP[4] );
_MNI4.elm1 := _MNI4.elm5*0.1;
if ( _MNI4.elm1 < UP[6] ) 
 then _MNI4.elm1 := UP[6];
goto _16;
_76:
if ( _MNI4.elm7 <= UP[7] ) 
 then goto _80;
_MNI4.elm2 := _MNI4.elm7*0.1;
if ( _MNI4.elm2 < UP[7] ) 
 then _MNI4.elm2 := UP[7];
goto _40;
_77:
if ( FS > UP[5] ) 
 then goto _78;
goto _80;
_78:
if ( _MNI4.elm14 = 134 ) 
 then goto _73;
_MNI4.elm9 := 1;
goto _36;
_80:
IW := 1;
goto _90;
_85:
IW := 4;
_90:
for I:=1 to N do
 begin
_95:
  G[I-1] := RM[K4+I-1];
 end;
if ( KP = 0 ) or ( (NI >= NP ) and ( ((NI-NP) Mod (KP)) = 0) ) 
 then goto _100;
MNI31(N,M,L,NI,X,FX,F);
_100:
RM[0] := NI;
RM[1] := _MNI3.elm4;
RM[2] := _MNI3.elm5;
end;

end.
