{    var   : }
{ N, M, L, FX, FS }
Unit MNI11_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNRDN_p, MNRDS_p, MNI21_p, MNI26_p, MNRDI_p, MNRDQ_p;

procedure MNI11(FUN :Proc_F4E_MN; GRAD :Proc_F5E_MN; var N :Integer;
                var M :Integer; var L :Integer; var A :Array of Extended;
                var B :Array of Extended; var X :Array of Extended;
                var FX :Extended; var F :Array of Extended;
                var FS :Extended; var G :Array of Extended;
                var I0 :Array of Integer; var R :Array of Extended;
                var S :Array of Extended; var R1 :Array of Extended;
                var RF :Array of Extended; MNI :Proc_MNI07);

implementation

procedure MNI11(FUN :Proc_F4E_MN; GRAD :Proc_F5E_MN; var N :Integer;
                var M :Integer; var L :Integer; var A :Array of Extended;
                var B :Array of Extended; var X :Array of Extended;
                var FX :Extended; var F :Array of Extended;
                var FS :Extended; var G :Array of Extended;
                var I0 :Array of Integer; var R :Array of Extended;
                var S :Array of Extended; var R1 :Array of Extended;
                var RF :Array of Extended; MNI :Proc_MNI07);
var
NIT,I,ID,IS_,J,IM :Integer;
T :Real;
GFP,R2,R3,R4 :Extended;
label
_5,_20,_25,_30,_35,_40,_45,_50,_55,_65,_67,_70,_75,_80,_85,_87,_90,
_100,_131,_132,_133,_134,_135,_140,_145,_160,_165,_170,_175,_176,_177,
_178,_180,_182,_185,_195,_200,_205,_210,_215;
begin
NIT := 0;
if ( _MNI4.elm10 <> 0 ) 
 then goto _210;
for I:=1 to N do
 begin
_5:
  R1[(I-1)+0*N] := X[I-1];
 end;
ID := 0;
IS_ := 0;
goto _160;
_20:
if ( ID <> 0 ) 
 then goto _35;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    if ( I = J ) 
     then goto _25;
    R[(I-1)+(J-1)*N] := 0.0;
    S[(I-1)+(J-1)*N] := 0.0;
    goto _30;
_25:
    R[(I-1)+(J-1)*N] := 1.0;
    S[(I-1)+(J-1)*N] := 1.0;
_30:
   end;
 end;
_35:
for I:=1 to N do
 begin
_40:
  R1[(I-1)+2*N] := R1[(I-1)+2*N]-X[I-1];
 end;
MNRDN(S,N,R2);
_45:
for I:=1 to N do
 begin
_50:
  R1[(I-1)+3*N] := R1[(I-1)+3*N]-G[I-1];
 end;
MNRDS(S,R1[0+3*N],N,R3);
if ( Abs(R3) > _MNI4.elm12*R2 ) 
 then goto _70;
if ( IS_ = 0 ) 
 then goto _55;
IS_ := 0;
ID := 0;
goto _87;
_55:
IS_ := 1;
MNRDN(R[0+(N-1)*N],N,R4);
for I:=1 to N do
 begin
  R1[(I-1)+2*N] := 0.5*S[(I-1)+0*N]*R4/R2;
  R1[(I-1)+1*N] := X[I-1]+R1[(I-1)+2*N];
  if ( R1[(I-1)+1*N] >= A[I-1] ) and ( R1[(I-1)+1*N] <= B[I-1] ) 
   then goto _65;
  ID := 0;
  goto _87;
_65:
 end;
MNI21(FUN,N,M,L,R1[0+1*N],R3,RF,R4);
MNI26(GRAD,N,M,L,R1[0+1*N],RF,R1[0+3*N],I0,R1[0+3*N]);
for I:=1 to N do
 begin
  if ( X[I-1] < A[I-1]+_MNI4.elm1 ) and ( R1[(I-1)+3*N] > 0 ) 
   then R1[(I-1)+3*N] := 0;
  if ( X[I-1] > B[I-1]-_MNI4.elm1 ) and ( R1[(I-1)+3*N] < 0 ) 
   then R1[(I-1)+3*N] := 0;
_67:
 end;
goto _45;
_70:
ID := ID+1;
MNRDI(S,R1[0+3*N],R1[0+4*N],N,N);
for I:=1 to N do
 begin
_75:
  R1[(I-1)+3*N] := S[(I-1)+0*N]/R3;
 end;
for J:=1 to _MNI4.elm13 do
 begin
  for I:=1 to N do
   begin
    R[(I-1)+(J-1)*N] := R[(I-1)+(J+0)*N];
_80:
    S[(I-1)+(J-1)*N] := S[(I-1)+(J+0)*N]-R1[(J+0)+4*N]*R1[(I-1)+3*N];
   end;
 end;
for I:=1 to N do
 begin
  R[(I-1)+(N-1)*N] := R1[(I-1)+2*N];
_85:
  S[(I-1)+(N-1)*N] := R1[(I-1)+3*N];
 end;
_87:
if ( _MNI4.elm8 = 3 )
 then goto _140;
_90:
if ( (_MNI4.elm10 Mod N) = 0 )
 then goto _100;
if ( _MNI4.elm8 = 1 ) or ( _MNI4.elm8 = 5 )
 then goto _140;
goto _160;
_100:
for I:=1 to N do
 begin
  R1[(I-1)+4*N] := X[I-1]-R1[(I-1)+0*N];
  if ( X[I-1] < A[I-1]+_MNI4.elm1 ) and ( R1[(I-1)+4*N] < 0 ) 
   then R1[(I-1)+4*N] := 0;
  if ( X[I-1] > B[I-1]-_MNI4.elm1 ) and ( R1[(I-1)+4*N] > 0 )
   then R1[(I-1)+4*N] := 0.0;
_131:
  R1[(I-1)+0*N] := X[I-1];
 end;
T := 0.0;
MNRDS(G,R1[0+4*N],N,R3);
MNRDN(R1[0+4*N],N,R4);
_132:
if ( R4 = 0 ) 
 then goto _140;
if ( R3/R4+_MNI4.elm12 < 0 ) 
 then goto _134;
if ( _MNI4.elm8 <= 1 ) 
 then goto _140;
if ( T <> 0 ) 
 then goto _160;
for I:=1 to N do
 begin
_133:
  R1[(I-1)+4*N] := R1[(I-1)+4*N]*0.5/R4-0.5*G[I-1]/_MNI4.elm7;
 end;
MNRDS(G,R1[0+4*N],N,R3);
MNRDN(R1[0+4*N],N,R4);
T := 1.0;
goto _132;
_134:
for I:=1 to N do
 begin
_135:
  R1[(I-1)+4*N] := R1[(I-1)+4*N]/R4;
 end;
GFP := R3/R4;
goto _170;
_140:
if ( ID < N ) 
 then goto _160;
MNRDI(S,G,R1[0+1*N],N,N);
MNRDQ(R,R1[0+1*N],R1[0+4*N],N);
MNRDN(R1[0+4*N],N,R4);
MNRDS(G,R1[0+4*N],N,R3);
if ( R3/R4 < _MNI4.elm12 ) 
 then goto _160;
for I:=1 to N do
 begin
_145:
  R1[(I-1)+4*N] := -R1[(I-1)+4*N]/R4;
 end;
GFP := -R3/R4;
goto _170;
_160:
GFP := -_MNI4.elm7;
IM := 0;
for I:=1 to N do
 begin
_165:
  R1[(I-1)+4*N] := -G[I-1]/_MNI4.elm7;
 end;
_170:
for I:=1 to N do
 begin
_175:
  R1[(I-1)+2*N] := X[I-1];
 end;
if ( (_MNI4.elm8 Mod 2) = 0 ) 
 then goto _177;
for I:=1 to N do
 begin
_176:
  R1[(I-1)+3*N] := G[I-1];
 end;
_177:
MNI(FUN,A,B,N,M,L,R1[0+2*N],FX,F,FS,X,R1[0+4*N],GFP,RF);
if ( _MNI4.elm9 <> 9 ) 
 then goto _182;
if ( _MNI4.elm7 > _MNI4.elm2 ) 
 then goto _178;
_MNI4.elm5 := _MNI4.elm1;
_MNI4.elm9 := 13;
goto _215;
_178:
if ( IM = 0 ) 
 then goto _215;
for I:=1 to N do
 begin
_180:
  R1[(I-1)+4*N] := -G[I-1]/_MNI4.elm7;
 end;
_MNI4.elm9 := _MNI4.elm14;
_MNI4.elm5 := _MNI4.elm1;
GFP := -_MNI4.elm7;
IM := 0;
goto _177;
_182:
MNI26(GRAD,N,M,L,X,F,G,I0,R1[0+5*N]);
MNRDN(G,N,_MNI4.elm6);
for I:=1 to N do
 begin
  if ( X[I-1] < A[I-1]+_MNI4.elm1 ) and ( G[I-1] > 0 ) 
   then G[I-1] := 0.0;
  if ( X[I-1] > B[I-1]-_MNI4.elm1 ) and ( G[I-1] < 0 ) 
   then G[I-1] := 0.0;
_185:
 end;
MNRDN(G,N,_MNI4.elm7);
NIT := NIT+1;
_MNI4.elm10 := _MNI4.elm10+1;
IM := 1;
if ( _MNI4.elm7 > _MNI4.elm12 ) 
 then goto _195;
_MNI4.elm9 := 5;
goto _215;
_195:
if ( _MNI4.elm9 = 134 ) 
 then goto _200;
if ( _MNI4.elm5 <= _MNI4.elm1 ) 
 then goto _215;
goto _210;
_200:
if ( _MNI4.elm5 > _MNI4.elm1 ) or ( _MNI4.elm7 > _MNI4.elm2 ) 
 then goto _205;
_MNI4.elm9 := 13;
goto _215;
_205:
if ( NIT < _MNI4.elm11 ) 
 then goto _210;
_MNI4.elm9 := 4;
goto _215;
_210:
if ( (_MNI4.elm8 Mod 2) <> 0 ) 
 then goto _20;
if ( _MNI4.elm8 = 2 ) 
 then goto _160;
goto _90;
_215:
_MNI4.elm11 := NIT;
end;

end.
